var startBoard = "\
--------\
--------\
--------\
---OX---\
---XO---\
--------\
--------\
--------";

var bgColor = "transparent";
var ah18Color = "black";
var textColor = "black";
var movesColor = "yellow";
var scoreColor = "darkkhaki";
var boardColor = "#33cc33";
var trialColor = "#33cccc";
var dotColor = "#196619";
var frame1Color = "#900000 #300000 #300000 #900000";
var frame2Color = "#600000";
var frame3Color = "#300000 #900000 #900000 #300000";

var BLACK = -1;
var WHITE = 1;
var EMPTY = 0;
var WALL = 9;
var PASS = -9;
var pos_A1 = 10;
var pos_H8 = 80;

var vectAry = new Array(10,9,8,1,-1,-8,-9,-10);
var vtBoard = new Array(91);
var dfBoard = new Array(64);
var kifuTable = new Array(64);
var flipStack = new Array(1200);
var nextColor = EMPTY;
var startMoveNo = 1;
var nextMoveNo = 1;
var lastMoveNo = 60;
var blackCount = 0;
var whiteCount = 0;
var dfBlackCount = 0;
var dfWhiteCount = 0;
var fStackP = 0;
var replayKif = "";
//var replayKif = "f5d6c3d3c4f4c5b3c2b4e3e6c6f6a5a4b5a6d7c7e7e8b6d8g3f7g5d1c1b1g6d2a2f2g8a7b8b7b2f3f1h2a8c8f8a1a3g4h3h4h5h6e2e1g1g7g2h1h7h8";
var trialKif = "";
var startColor = EMPTY;
var startMode = "replay"; //replay, kifu, trial
var currentMode = "replay"; //replay, kifu, trial
var disableFirst = false;
var disablePrev = false;
var disableNext = false;
var disableLast = false;
var disableKifu = false;
var currentBrowserName;
var currentBrowserType;

String.prototype.trim = function() {
  return this.replace(/^[ \s\n\r\t]+|[ \s\n\r\t]+$/g, '');
}

String.prototype.trimAll = function() {
  return this.replace(/[ \s\n\r\t]+/g, '');
}

function getInitParam()
{
  var strParameter;
  var strParamAry;
  var strParam;
  var paraSep,lineSep;
  
  if (!(strParameter = location.search.substr(1))) {
    return false;
  }

  strParameter = decodeURIComponent(strParameter);
  
  if (strParameter.indexOf("=") != -1) {
  	paraSep = "="; lineSep = "&";
  }
  else if (strParameter.indexOf(":") != -1) {
  	paraSep = ":"; lineSep = ";";
  }
  else {
    return false;
  }
  
  strParamAry = strParameter.split(lineSep);

  for (var i = 0; i < strParamAry.length; i++) {
    if (!strParamAry[i].length) {
      continue;
    }
    strParam = strParamAry[i].split(paraSep);
    if (!(strParam[1])) {
      continue;
    }

    switch (strParam[0].toLowerCase().trim()) {
      case "start_board":
        if (strParam[1].trimAll().length == 64) {
          startBoard = strParam[1].trimAll();
        }
        else if (strParam[1].trimAll().length == 65) {
          startBoard = strParam[1].trimAll().substr(0,64);
          switch (strParam[1].trimAll().substr(64,1)) {
          	case "x":
          	case "X":
          		startColor = BLACK;
          		break;
          	case "o":
          	case "O":
          		startColor = WHITE;
          		break;
          }
        }
        else {
        		alert("board parameter error.");
        }
        break;
      case "start_color":
      		switch (strParam[1].toLowerCase().trimAll()) {
      			case "black":
							startColor = BLACK;
      				break;
      			case "white":
							startColor = WHITE;
      				break;
      		}
        break;
      case "board_color":
        strColor = strParam[1].trim();
        if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
          try { 
            document.getElementById("char_a").style.color = strColor;
          }
          catch(e) {
            alert("Error: boardcolor");
            continue;
          }
          boardColor = strColor;
        }
        else {
          boardColor = "#" + strColor;
        }
       	break;
      case "trial_color":
        strColor = strParam[1].trim();
        if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
          try { 
            document.getElementById("char_a").style.color = strColor;
          }
          catch(e) {
            alert("Error: trialcolor");
            continue;
          }
          trialColor = strColor;
        }
        else {
          trialColor = "#" + strColor;
        }
      	break;
      case "ah18_color":
        strColor = strParam[1].trim();
        if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
          try { 
            document.getElementById("char_a").style.color = strColor;
          }
          catch(e) {
            alert("Error: ah18color");
            continue;
          }
          ah18Color = strColor;
        }
        else {
          ah18Color = "#" + strColor;
        }
        break;
      case "bgcolor":
        strColor = strParam[1].trim();
        if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
          try { 
            document.getElementByTagName("hamlite").style.backgroundColor =  strColor;
          }
          catch(e) {
              alert("Error: bgcolor");
              continue;
          }
          bgColor = strColor;
        }
        else {
          bgColor = "#" + strColor;
        }
        break;
      case "frame_color":
        strColor = strParam[1].trim();
        if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
          try { 
            document.getElementById("frame_1").style.borderColor = strColor;
          }
          catch(e) {
            alert("Error: framecolor");
            continue;
          }
          frame1Color = strColor;
          frame2Color = strColor;
          frame3Color = strColor;
        }
        else {
          var rCol,gCol,bCol;
          rCol = parseInt(strColor.substr(0,2),16);
          gCol = parseInt(strColor.substr(2,2),16);
          bCol = parseInt(strColor.substr(4,2),16);
          var rStr,gStr,bStr;
          rStr = (rCol/2).toString(16);
          gStr = (gCol/2).toString(16);
          bStr = (bCol/2).toString(16);
          var darkCol = "#"
                  + ((rStr.length < 2) ? "0" + rStr : rStr)
                  + ((gStr.length < 2) ? "0" + gStr : gStr)
                  + ((bStr.length < 2) ? "0" + bStr : bStr);
          rStr = (rCol*1.5).toString(16);
          gStr = (gCol*1.5).toString(16);
          bStr = (bCol*1.5).toString(16);
          var lightCol = "#"
                   + ((rStr.length < 2) ? "0" + rStr : rStr)
                   + ((gStr.length < 2) ? "0" + gStr : gStr)
                   + ((bStr.length < 2) ? "0" + bStr : bStr);
          var normalCol = "#" + strColor;
          frame1Color = lightCol + " " + darkCol + " " + darkCol + " " + lightCol;
          frame2Color = normalCol;
          frame3Color = darkCol + " " + lightCol + " " + lightCol + " " + darkCol;
        }
        break;
      case "kifu":
        replayKif = checkKifFormat(strParam[1].trimAll());
        break;
      case "matrix":
        replayKif = convMatrixToKif(strParam[1].trimAll());
        break;
      default:
        break;
    }
  }
}

function initBoardPrint()
{
  var i = 0, ahStr = "abcdefgh", doc = document;
  var strID = "", strChar = "", strLine = "";
  var strText = "", strStone = "", strEval = "";
  var faceColor = "", backColor = "", textColor = "";
  var evalColor = "yellow";
  var strHF = '<div class="ham_face" id="face_';
  var strHB = '<div class="ham_back" id="back_';
  var strHE = '<div class="ham_eval" id="eval_';
  var strHT = '<div class="ham_text" id="text_';
  var webClient = checkBrowserName();

  doc.getElementById("hamlite").style.backgroundColor = bgColor;
  doc.getElementById("frame_2").style.backgroundColor = boardColor;
  doc.getElementById("frame_1").style.borderColor = frame1Color;
  doc.getElementById("frame_2").style.borderColor = frame2Color;
  doc.getElementById("frame_3").style.borderColor = frame3Color;

  dfBlackCount = 0;
  dfWhiteCount = 0;

  for (var y = 0; y < 8; y++) {
    doc.getElementById("char_" + ahStr.charAt(y)).style.color = ah18Color;
    doc.getElementById("char_" + String(y+1)).style.color = ah18Color;
    for (var x = 0; x < 8; x++) {
      strID = ahStr.charAt(x) + String(y+1);
      strChar = startBoard.charAt(i++);
      switch (strChar) {
        case "X":
          strStone = "●";
          strText = "";
          strEval = "";
          faceColor = 'black';
          backColor = 'white';
          textColor = 'black';
          evalColor = 'white';
          dfBoard[y*8+x] = BLACK;
          dfBlackCount++;
          break;
        case "x":
          strStone = "●";
          strText = "・";
          strEval = "";
          faceColor = 'black';
          backColor = 'white';
          textColor = 'magenta';
          evalColor = 'white';
          dfBoard[y*8+x] = BLACK;
          dfBlackCount++;
          break;
        case "*":
          strStone = "●";
          strText = "＋";
          strEval = "";
          faceColor = 'black';
          backColor = 'white';
          textColor = 'magenta';
          evalColor = 'white';
          dfBoard[y*8+x] = BLACK;
          dfBlackCount++;
          break;
        case "O":
          strStone = "●";
          strText = "";
          strEval = "";
          faceColor = 'white';
          backColor = 'black';
          textColor = 'white';
          evalColor = 'black';
          dfBoard[y*8+x] = WHITE;
          dfWhiteCount++;
          break;
        case "o":
          strStone = "●";
          strText = "・";
          strEval = "";
          faceColor = 'white';
          backColor = 'black';
          textColor = 'magenta';
          evalColor = 'black';
          dfBoard[y*8+x] = WHITE;
          dfWhiteCount++;
          break;
        case "@":
          strStone = "●";
          strText = "＋";
          strEval = "";
          faceColor = 'white';
          backColor = 'black';
          textColor = 'magenta';
          evalColor = 'black';
          dfBoard[y*8+x] = WHITE;
          dfWhiteCount++;
          break;
        case "-":
          strStone = "";
          strText = "";
          strEval = "";
          faceColor = boardColor;
          backColor = boardColor;
          textColor = boardColor;
          evalColor = 'yellow';
          dfBoard[y*8+x] = EMPTY;
          break;
        case "+":
          strStone = "";
          strText = "・";
          strEval = "";
          faceColor = boardColor;
          backColor = boardColor;
          textColor = '#196619';
          evalColor = 'yellow';
          dfBoard[y*8+x] = EMPTY;
          break;
        default:
          strStone = "";
          strText = strChar;
          strEval = "";
          faceColor = boardColor;
          backColor = boardColor;
          textColor = '#ffff00';
          evalColor = 'yellow';
          dfBoard[y*8+x] = EMPTY;
          break;
      }
      strLine = strHF + strID + '">' + strStone + '</div>'
              + strHB + strID + '">' + strStone + '</div>'
              + strHE + strID + '">' + strEval  + '</div>'
              + strHT + strID + '">' + strText  + '</div>';
      doc.write(strLine);
      doc.getElementById("face_" + strID).style.color = faceColor;
      doc.getElementById("back_" + strID).style.color = backColor;
      doc.getElementById("text_" + strID).style.color = textColor;
      var evalId = doc.getElementById("eval_" + strID);
      evalId.style.color = evalColor;
      if (webClient == "IPHONE") {
        evalId.style.fontSize = "60%";
      }
    }
  }
  doc.write('<div class="x_corner" id="dot_lu"></div>');
  doc.write('<div class="x_corner" id="dot_ru"></div>');
  doc.write('<div class="x_corner" id="dot_ld"></div>');
  doc.write('<div class="x_corner" id="dot_rd"></div>');
}

function currentBoardPrint()
{
  var nPos = 0;
  for (var y = 0; y < 8; y++) {
    for (var x = 0; x < 8; x++) {
      nPos = (y + 1) * 9 + x + 1;
      printStone(nPos, vtBoard[nPos], 0);
    }
  }
}

function printScore(bCount,wCount)
{
  document.getElementById("BlackCount").innerHTML = ((bCount < 10) ? String(bCount)+" " : String(bCount));
  document.getElementById("WhiteCount").innerHTML = ((wCount < 10) ? String(wCount)+" " : String(wCount));
}

function printNextMove(nextMove, lastMove)
{
  if (nextMove > lastMove) {
    document.getElementById("MoveNo").innerHTML = "--";
  }
  else {
    document.getElementById("MoveNo").innerHTML = ((nextMove < 10) ? String(nextMove)+" " : String(nextMove));
  }
}

function printNextColor(nextCol)
{
  switch (nextCol) {
    case BLACK:
      document.getElementById("BlackFrame").style.borderColor = movesColor;
      document.getElementById("WhiteFrame").style.borderColor = scoreColor;
      break;
    case WHITE:
      document.getElementById("BlackFrame").style.borderColor = scoreColor;
      document.getElementById("WhiteFrame").style.borderColor = movesColor;
      break;
    default:
      document.getElementById("BlackFrame").style.borderColor = scoreColor;
      document.getElementById("WhiteFrame").style.borderColor = scoreColor;
  }
}

function checkKifFormat(inputKif)
{
  var inKif = inputKif.toLowerCase();
  var x_AtoH;
  var y_1to8;
  var strKif = "";

  for (var i = 0 ; i < inKif.length; i += 2) {
    x_AtoH = inKif.charAt(i);
    if (x_AtoH >= 'a' && x_AtoH <= 'h') {
      strKif = strKif.concat(x_AtoH);
    }
    else {
      break;
    }
    y_1to8 = inKif.charAt(i+1);
    if (y_1to8 >= '1' && y_1to8 <= '8') {
      strKif = strKif.concat(y_1to8);
    }
    else {
      break;
    }
  }

  return strKif;
}

function convMatrixToKif(inputMatrix)
{
  var inMatrix = inputMatrix.toLowerCase();
  var matrixAry = inMatrix.split("|");
  var sortAry = new Array(64);
  var strMoveNo = "";
  var strKif = "";
  var idx = 0;

  for (var i = 0; i <= 60; i++) {
    sortAry[i] = NaN;
  }

  for (var i = 0; i < matrixAry.length; i++) {
    strMoveNo = matrixAry[i];
    if (!strMoveNo.length) {
      continue;
    }
    if (idx < 64 && strMoveNo.search(/[0-9]/i) != -1) {
      sortAry[parseInt(strMoveNo)] = idx_to_ah18(idx);
    }
    idx++;
  }

  for (var i = 1; i <= 60; i++) {
    if (sortAry[i] != NaN) {
      strKif = strKif.concat(sortAry[i]);
    }
  }

  return strKif;
}

function pos_to_ah18(nPos)
{
  var strAtoH = "abcdefgh";
  var str1to8 = "12345678";
  var strX = strAtoH.charAt(nPos%9-1);
  var strY = str1to8.charAt(Math.floor(nPos/9)-1);
  return strX + strY;
}

function ah18_to_pos(ah18)
{
  var strAH18 = ah18.toLowerCase();
  var strAtoH = "abcdefgh";
  var x = strAtoH.search(strAH18.charAt(0));
  var y = parseInt(strAH18.charAt(1)) - 1;
  return (x+1)+(y+1)*9;
}

function pos_to_idx(nPos)
{
  return (nPos%9-1) + (Math.floor(nPos/9)-1) * 8;
}

function idx_to_pos(nIdx)
{
  return (nIdx%8+1) + (Math.floor(nIdx/8)+1) * 9;
}

function idx_to_ah18(nIdx)
{
  var strAtoH = "abcdefgh";
  var str1to8 = "12345678";
  var strX = strAtoH.charAt(nIdx%8);
  var strY = str1to8.charAt(Math.floor(nIdx)/8);
  return strX + strY;
}

function ah18_to_idx(ah18)
{
  var strAH18 = ah18.toLowerCase();
  var strAtoH = "abcdefgh";
  var x = strAtoH.search(strAH18.charAt(0));
  var y = parseInt(strAH18.charAt(1)) - 1;
  return x+y*8;
}

function printStone(nPos, nCol, nMove)
{
  var strAH18 = pos_to_ah18(nPos);

  switch (nCol) {
    case BLACK:
      document.getElementById("face_"+strAH18).style.color = "black";
      document.getElementById("back_"+strAH18).style.color = "white";
      document.getElementById("eval_"+strAH18).style.color = "white";
      document.getElementById("text_"+strAH18).style.color = "yellow";
      document.getElementById("face_"+strAH18).innerHTML = "●";
      document.getElementById("back_"+strAH18).innerHTML = "●";
      document.getElementById("eval_"+strAH18).innerHTML = ((nMove == 0) ? "" : String(nMove));
      document.getElementById("text_"+strAH18).innerHTML = "";
      break;
    case WHITE:
      document.getElementById("face_"+strAH18).style.color = "white";
      document.getElementById("back_"+strAH18).style.color = "black";
      document.getElementById("eval_"+strAH18).style.color = "black";
      document.getElementById("text_"+strAH18).style.color = "yellow";
      document.getElementById("face_"+strAH18).innerHTML = "●";
      document.getElementById("back_"+strAH18).innerHTML = "●";
      document.getElementById("eval_"+strAH18).innerHTML = ((nMove == 0) ? "" : String(nMove));
      document.getElementById("text_"+strAH18).innerHTML = "";
      break;
    default:
      document.getElementById("face_"+strAH18).innerHTML = "";
      document.getElementById("back_"+strAH18).innerHTML = "";
      document.getElementById("eval_"+strAH18).innerHTML = "";
      document.getElementById("text_"+strAH18).innerHTML = "";
  }
}

function checkKifPutEnable(currentKif, startCol)
{
  var nPos = 0;
  var nCol = startCol;
  var tempKif = currentKif;
  var lastMove = currentKif.length / 2;

  for (i = 0; i < 64; i++)
    kifuTable[i] = dfBoard[i];

  for ( var i = 0; i < lastMove; i++) {
    nPos = ah18_to_pos(currentKif.substr(i * 2, 2));
    if (!putStoneBoard(nPos, nCol)) {
      nCol = -nCol;
      if  (!putStoneBoard(nPos, nCol)) {
        tempKif = currentKif.substr(0,(i + 1) * 2);
        alert("kifu error??");
        break;
      }
    }
    kifuTable[pos_to_idx(nPos)] = (i + 1 + 10) * nCol;
    nCol = -nCol;
  }
  return tempKif;
}

function isPutEnable(nPos, nCol)
{
  var nCount = 0, nPosInc = 0, nVect = 0;

  if (vtBoard[nPos] != EMPTY)
    return false;

  for (var i = 0; i < 8; i++) {
    nVect = vectAry[i];
    nPosInc = nPos + nVect;
    nCount = 0;
    while (vtBoard[nPosInc] == -nCol) {
      nPosInc += nVect;
      nCount++;
    }
    if (nCount > 0 && vtBoard[nPosInc] == nCol) {
      return true;
    }
  }

  return false;
}

function putStoneBoard(nPos, nCol)
{
  var nCount = 0, nVect = 0, nPosInc = 0, nTurn = 0;

  if (vtBoard[nPos] != EMPTY)
    return 0;

  for (var i = 0; i < 8; i++) {
    nVect = vectAry[i];
    nPosInc = nPos + nVect;
    nCount = 0;
    while (vtBoard[nPosInc] == -nCol) {
      nPosInc += nVect;
      nCount++;
    }
    if (nCount > 0 && vtBoard[nPosInc] == nCol) {
      nTurn += nCount;
      while (nCount > 0) {
        nPosInc -= nVect;
        vtBoard[nPosInc] = nCol;
        pos_Push(nPosInc);
        nCount--;
      }
    }
  }

  if (nTurn > 0) {
    vtBoard[nPos] = nCol;
    pos_Push(nPos);
    pos_Push(nTurn);
  }

  return nTurn;
}

function putStonePrint(nPos, nCol)
{
  var nTurn;
  
  if ((nTurn = putStoneBoard(nPos, nCol)) == 0) {
    return 0;
  }

  printStone(nPos, nCol, 0);
  var nPeek = fStackP - 3;
  for (var i = 0; i < nTurn; i++) {
    printStone(flipStack[nPeek--], nCol, 0);
  }

  return nTurn;
}

function pos_Push(nPos)
{
  flipStack[fStackP++] = nPos;
}

function pos_Pop()
{
  return flipStack[--fStackP];
}

function countStone(nCol, nTurn, nOwn)
{
  if (nCol == BLACK) {
    blackCount = blackCount + nTurn + nOwn;
    whiteCount = whiteCount - nTurn;
  }
  else {
    blackCount = blackCount - nTurn;
    whiteCount = whiteCount + nTurn + nOwn;
  }
}

function undoFlips(nTurn, nCol, flag)
{
  var nPos = pos_Pop();
  var nPos2 = nPos;

  vtBoard[nPos] = EMPTY;
  if (flag) {
    printStone(nPos, EMPTY);
  }

  while(nTurn-- > 0) {
    nPos = pos_Pop();
    vtBoard[nPos] = nCol;
    if (flag) {
      printStone(nPos, nCol, 0);
    }
  }
  return nPos2;
}

function checkNextMove(nPos, nCol)
{
  var nextCol = -nCol;

  if (!isPutEnable(nPos, nextCol)) {
    nextCol = -nextCol;
    if  (!isPutEnable(nPos, nextCol)) {
      nextCol = EMPTY;
      alert("kifu error!?");
    }
    else {
      pos_Push(PASS);
    }
  }

  return nextCol;
}

function initVirtualBoard()
{
	for (var i = 0; i < 9; i++) {
		vtBoard[i] = WALL;
		vtBoard[(i+1)*9] = WALL;
		vtBoard[i+82] = WALL;
	}
	
  for (var i = 0; i < 64; i++) {
    vtBoard[idx_to_pos(i)] = dfBoard[i];
  }
}

function initBoardStatus()
{
  fStackP = 0;
  startMoveNo = dfBlackCount + dfWhiteCount - 4 + 1;
  nextMoveNo = startMoveNo;
  lastMoveNo = startMoveNo + replayKif.length / 2 - 1;
  if (startColor == EMPTY) {
  	if (nextMoveNo % 2) {
  		startColor = BLACK;
  	}
  	else {
  		startColor = WHITE;
  	}
  }
  nextColor = startColor;
  blackCount = dfBlackCount;
  whiteCount = dfWhiteCount;
  currentMode = startMode;
  currentBrowserName = checkBrowserName();
  currentBrowserType = checkBrowserType();
}

function moveFirst()
{
  if (disableFirst)
    return;
  
  initVirtualBoard();
  initBoardStatus();
  currentBoardPrint();
  printScore(blackCount,whiteCount);
  printNextColor(startColor);
  printNextMove(nextMoveNo,lastMoveNo);
  onPutEnable();
  setTimeout("setGrayOutButton()",1);
}

function movePrev()
{
  if (disablePrev)
    return;
  
  var nPos=0, nTurn=0;

  if (fStackP <= 0)
    return;
    
  nextColor = -nextColor;
  if ((nTurn = pos_Pop()) == PASS) {
    nTurn = pos_Pop();
    nextColor = -nextColor;
  }

  undoFlips(nTurn, -nextColor, true);
  countStone(nextColor, -nTurn, -1);
  printScore(blackCount, whiteCount);
  printNextColor(nextColor);
  nextMoveNo--;
  printNextMove(nextMoveNo, lastMoveNo);

  var putMark = document.getElementById("PutMark").checked;
  if (putMark) {
    putMarkPrint(replayKif.substr((nextMoveNo - startMoveNo)*2, 2),"","magenta");
    if (nextMoveNo > 1) {
      putMarkPrint(replayKif.substr((nextMoveNo - startMoveNo -1)*2, 2),"・","magenta");
    }
  }
  onPutEnable();
  setTimeout("setGrayOutButton()",1);
}

function moveNext()
{
  if (disableNext)
    return;

  var ah18 = replayKif.substr((nextMoveNo - startMoveNo)*2, 2);
  var nTurn = putStonePrint(ah18_to_pos(ah18), nextColor);
  var putMark = document.getElementById("PutMark").checked;
  if (putMark) {
    putMarkPrint(ah18,"・","magenta");
    if (nextMoveNo > 1) {
      putMarkPrint(replayKif.substr((nextMoveNo - startMoveNo - 1)*2, 2),"","magenta");
    }
  }
  
  if (nextMoveNo > lastMoveNo)
    return;
  
  countStone(nextColor, nTurn, 1);
  printScore(blackCount, whiteCount);

  if (nextMoveNo < lastMoveNo) {
    ah18 = replayKif.substr((nextMoveNo - startMoveNo + 1)*2, 2);
    nextColor = checkNextMove(ah18_to_pos(ah18), nextColor);
    printNextColor(nextColor);
  }
  else {
    nextColor = -nextColor;
    printNextColor(EMPTY);
  }

  nextMoveNo++;
  printNextMove(nextMoveNo, lastMoveNo);
  onPutEnable();
  setTimeout("setGrayOutButton()",1);
}

function moveLast()
{
  if (disableLast)
    return;

  var nPos = 0, nTurn = 0;

  for ( var i = nextMoveNo; i < lastMoveNo; i++) {
    nPos = ah18_to_pos(replayKif.substr((i-startMoveNo) * 2, 2));
    nTurn = putStoneBoard(nPos, nextColor);
    countStone(nextColor, nTurn, 1);
    nPos = ah18_to_pos(replayKif.substr((i-startMoveNo+1) * 2, 2));
    nextColor = checkNextMove(nPos, nextColor);
  }

  nPos = ah18_to_pos(replayKif.substr((i-startMoveNo) * 2, 2));
  nTurn = putStoneBoard(nPos, nextColor);
  countStone(nextColor, nTurn, 1);
  nextColor = -nextColor;
  nextMoveNo = lastMoveNo + 1;

  currentBoardPrint();
  printScore(blackCount, whiteCount);
  printNextColor(EMPTY);
  printNextMove(nextMoveNo, lastMoveNo);

  setTimeout("setGrayOutButton()",1);
}

function kifuAndReturn()
{
  switch (currentMode) {
    case "replay":
      currentMode = "kifu";
      kifPrint();
      switchScorePanel("kifu");
      document.getElementById("KifuText").value = replayKif;
      document.getElementById("kifu").value = "return";
      disabledButton(true,true,false,true,true);
      break;
    case "kifu":
      currentMode = "replay";
      currentBoardPrint();
      switchScorePanel("score");
      printScore(blackCount, whiteCount);
      printNextColor(nextColor);
      printNextMove(nextMoveNo, lastMoveNo);
      document.getElementById("kifu").value = "kifu";
      disabledButton(false,false,false,false,false);
      setGrayOutButton();
      break;
    case "trial":
      break;
    default:
      
  }
}

function onPutMark()
{
  var putMark = document.getElementById("PutMark").checked;
  if (putMark && nextMoveNo > 1) {
    putMarkPrint(replayKif.substr((nextMoveNo-startMoveNo-1)*2, 2),"・","magenta");
  }
  else {
    putMarkPrint(replayKif.substr((nextMoveNo-startMoveNo-1)*2, 2),"","magenta");
  }
}

function onPutEnable()
{
  var putEnable = document.getElementById("PutEnable").checked;
  if (putEnable && nextMoveNo <= lastMoveNo) {
    putEnablePrint("・", nextColor);
  }
  else {
    putEnablePrint("", nextColor);
  }
}

function setGrayOutButton()
{
  if (fStackP <= 0) {
    document.getElementById("first").disabled = true;
    document.getElementById("prev").disabled = true;
    disableFirst = true;
    disablePrev = true;
  }
  else {
    document.getElementById("first").disabled = false;
    document.getElementById("prev").disabled = false;
    disableFirst = false;
    disablePrev = false;
  }

  if (nextMoveNo > lastMoveNo) {
    document.getElementById("next").disabled = true;
    document.getElementById("last").disabled = true;
    disableNext = true;
    disableLast = true;
  }
  else  {
    document.getElementById("next").disabled = false;
    document.getElementById("last").disabled = false;
    disableNext = false;
    disableLast = false;
  }
}

function disabledButton(bFirst,bPrev,bKifu,bNext,bLast)
{
  if (bFirst) {
    document.getElementById("first").disabled = true;
    disableFirst = true;
  }
  else {
    document.getElementById("first").disabled = false;
    disableFirst = false;
  }

  if (bPrev) {
    document.getElementById("prev").disabled = true;
    disablePrev = true;
  }
  else {
    document.getElementById("prev").disabled = false;
    disablePrev = false;
  }

  if (bKifu) {
    document.getElementById("kifu").disabled = true;
    disableKifu = true;
  }
  else  {
    document.getElementById("kifu").disabled = false;
    disableKifu = false;
  }

  if (bNext) {
    document.getElementById("next").disabled = true;
    disableNext = true;
  }
  else  {
    document.getElementById("next").disabled = false;
    disableNext = false;
  }

  if (bLast) {
    document.getElementById("last").disabled = true;
    disableLast = true;
  }
  else  {
    document.getElementById("last").disabled = false;
    disableLast = false;
  }
}

function kifPrint()
{
  var nCol, nMove;
  
  for (var i = 0; i < 64; i++) {
    if (kifuTable[i] < -10) {
      nCol = BLACK;
      nMove = -kifuTable[i] - 10;
    }
    else if (kifuTable[i] > 10) {
      nCol = WHITE;
      nMove = kifuTable[i] - 10;
    }
    else {
      nCol = kifuTable[i];
      nMove = 0;
      
    }
    printStone(idx_to_pos(i), nCol, nMove);
  }
}

function putMarkPrint(strAH18,strChar,strCol)
{
  document.getElementById("text_"+strAH18).style.color = strCol;
  document.getElementById("text_"+strAH18).innerHTML = strChar;
}

function putEnablePrint(strChar, nCol)
{
  var nPos = 0, bPass = true;

  for (nPos = pos_A1; nPos <= pos_H8; nPos++) {
    if(vtBoard[nPos] != EMPTY) continue;
    if(isPutEnable(nPos,nCol)) {
      bPass = false;
      putMarkPrint(pos_to_ah18(nPos),strChar,dotColor);
    }
    else {
      putMarkPrint(pos_to_ah18(nPos),"",dotColor);
    }
  }

  if (bPass) {
    for (nPos = pos_A1; nPos <= pos_H8; nPos++) {
      if(vtBoard[nPos] != EMPTY) continue;
      if(isPutEnable(nPos,-nCol)) {
        bPass = false;
        putMarkPrint(pos_to_ah18(nPos),strChar,dotColor);
      }
      else {
        putMarkPrint(pos_to_ah18(nPos),"",dotColor);
      }
    }
  }
}

function inputKifString()
{
  if (currentMode == "kifu") {
    var inputKif = document.getElementById("KifuText").value;
    inputKif = inputKif.toLowerCase().trimAll();
    if (!(inputKif==null)) {
      for (var i = 0; i < 64; i++) {
        dfBoard[i] = EMPTY;
      }
      dfBoard[ah18_to_idx("d4")] = WHITE;
      dfBoard[ah18_to_idx("e4")] = BLACK;
      dfBoard[ah18_to_idx("d5")] = BLACK;
      dfBoard[ah18_to_idx("e5")] = WHITE;
      initVirtualBoard();
      initBoardStatus();
      replayKif = checkKifPutEnable(inputKif, BLACK);
      document.getElementById("KifuText").select();
      kifPrint();
      initVirtualBoard();
      initBoardStatus();
      currentMode = "kifu";
    }
  }
}

function switchScorePanel(strMode)
{
  var strHTML = "";
  
  switch (strMode) {
    case "score" :
      strHTML = '<span id="BlackFrame">'
              + '<span id="BlackStone">●</span><span id="BlackCount"></span>'
              + '</span>'
              + '<span id="WhiteFrame">'
              + '<span id="WhiteStone">●</span>'
              + '<span id="WhiteCount"></span>'
              + '</span>'
              + '<span id="NextMove"> Next</span>'
              + '<span id="MoveNo"></span>'
              + '<input type="checkbox" id="endGameSolv" disabled="true"></input>';
      break;
    case "kifu" :
      strHTML = '<input type="text" id="KifuText" onClick="this.select();" onchange="setButtonOn();" onPaste="setButtonOn();" />'
              + '<input type="button" value="SET" id="SetKifu" onClick="inputKifString();" disabled="true" />';
      break;
    default:
      alert("error: switchScorePanel()");
  }

  document.getElementById("score_panel").innerHTML = strHTML;
}

function setButtonOn()
{
  document.getElementById("SetKifu").disabled = false;
}

function checkBrowserType()
{
  var webBrowser = navigator.userAgent;
  var browserType = "PCBROWSER";

  if (webBrowser.match(/iPhone/i) || webBrowser.match(/iPod/i)) {
    browserType = "SMARTPHONE";
  }
  else if (webBrowser.match(/MSIE/i)) {
  }
  else if (webBrowser.match(/Opera/i)) {
  }
  else if (webBrowser.match(/Firefox/i)) {
  }
  else if (webBrowser.match(/Chrome/i)) {
  }
  else if (webBrowser.match(/Safari/i)) {
  }
  else {
    browserType = "SMARTPHONE";
  }

  return browserType;
}

function checkBrowserName()
{
  var webBrowser = navigator.userAgent;
  var browserName = "OTHER";

  if (webBrowser.match(/iPhone/i) || webBrowser.match(/iPod/i)) {
    browserName = "IPHONE";
  }
  else if (webBrowser.match(/MSIE/i)) {
    browserName = "MSIE";
  }
  else if (webBrowser.match(/Opera/i)) {
    browserName = "OPERA";
  }
  else if (webBrowser.match(/Firefox/i)) {
    browserType = "FIREFOX";
  }
  else if (webBrowser.match(/Chrome/i)) {
    browserName = "CHROME";
  }
  else if (webBrowser.match(/Safari/i)) {
    browserName = "SAFARI";
  }

  return browserName;
}

function selectFunction(browserType, objFunction)
{
   if (browserType == currentBrowserType) {
      objFunction();
   }
}